ListBpGraph::Snapshot Class Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions
ListBpGraph::Snapshot Class Reference

## Detailed Description

Class to make a snapshot of the graph and restore it later.

The newly added nodes and edges can be removed using the restore() function.

Note
  After a state is restored, you cannot restore a later state, i.e. you cannot add the removed nodes and edges again using another Snapshot instance.

Warning
  Node and edge deletions and other modifications (e.g. changing the end-nodes of edges or contracting nodes) cannot be restored. These events invalidate the snapshot. However, the edges and nodes that were added to the graph after making the current snapshot can be removed without invalidating it.

`#include <lemon/list_graph.h>`

## Public Member Functions
| Snapshot ()
| Default constructor. More...
| Snapshot (ListBpGraph &gr)
| Constructor that immediately makes a snapshot. More...
void | save (ListBpGraph &gr)
| Make a snapshot. More...
void | restore ()
| Undo the changes until the last snapshot. More...
bool | valid () const
| Returns `true` if the snapshot is valid. More...

## Constructor & Destructor Documentation

Snapshot | ( |  | ) |
| inline

Default constructor. You have to call save() to actually make a snapshot.

Snapshot | ( | ListBpGraph & | gr | ) |
| inline

This constructor immediately makes a snapshot of the given graph.

## Member Function Documentation

void save | ( | ListBpGraph & | gr | ) |
| inline

This function makes a snapshot of the given graph. It can be called more than once. In case of a repeated call, the previous snapshot gets lost.

void restore | ( |  | ) |
| inline

This function undos the changes until the last snapshot created by save() or Snapshot(ListBpGraph&).

Warning
  This method invalidates the snapshot, i.e. repeated restoring is not supported unless you call save() again.

bool valid | ( |  | ) | const
| inline

This function returns `true` if the snapshot is valid.